/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.bsvrz.dua.bastband.bastband.dvs.funclib.objectwrapper;

/**
 * History:
 *
 * $Log: StrassenKlasse.java,v $
 * Revision 1.1  2007/07/04 11:44:16  Trier
 * Neuordnung
 *
 * Revision 1.1.1.1  2007/06/20 09:56:26  Trier
 * dvs alles
 *
 * Revision 1.4  2006/04/28 05:48:50  Trier
 * Generics 1.5 verwendet
 *
 * Revision 1.3  2005/06/13 14:17:09  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.2  2005/01/25 09:43:11  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.1  2005/01/21 13:26:10  Trier
 * <Kein Kommentar eingegeben>
 *
 */

import java.util.HashMap;

/**
 * Repr&auml;sentieren die Strassenklassen Bundesautobahn, Bundesstrasse,
 * Landesstraße usw.
 */
public class StrassenKlasse {

	private String _Name;
	private char _Abbreviation;

	private static HashMap<String, StrassenKlasse> hashMapNameAsKey;

	public static final StrassenKlasse BUNDESAUTOBAHN = new StrassenKlasse(
			"Autobahn", 'A');
	public static final StrassenKlasse BUNDESSTRASSE = new StrassenKlasse(
			"Bundesstraße", 'B');
	public static final StrassenKlasse LANDESSTRASSE = new StrassenKlasse(
			"Landesstraße", 'L');
	public static final StrassenKlasse STADTSTRASSE = new StrassenKlasse(
			"Stadtstraße", 'S');
	public static final StrassenKlasse KREISSTRASSE = new StrassenKlasse(
			"Kreisstraße", 'K');
	public static final StrassenKlasse GEMEINDESTRASSE = new StrassenKlasse(
			"Gemeindestraße", 'G');

	private StrassenKlasse(final String name, final char abbreviation) {
		try {
			_Name = name;
			_Abbreviation = abbreviation;
			if (StrassenKlasse.hashMapNameAsKey == null) {
				StrassenKlasse.hashMapNameAsKey = new HashMap<>();
			}
			StrassenKlasse.hashMapNameAsKey.put(name.toLowerCase(), this);
		} catch (final Exception e) {
			e.printStackTrace();
		}

	}

	@Override
	public String toString() {
		return _Name;
	}

	public String getName() {
		return _Name;
	}

	public char getAbbreviation() {
		return _Abbreviation;
	}

	public static StrassenKlasse getInstanceByName(final String name) {
		return StrassenKlasse.hashMapNameAsKey.get(name.toLowerCase());
	}

}
